//
//  SyntaxTreeNode.swift
//  Ballard
//
//  Created by Brent Simmons on 4/26/19.
//  Copyright © 2019 Ranchero Software. All rights reserved.
//

import Foundation

// This is a node in the Abstract Syntax Tree (AST) generated by the parser.
// Concrete types know how to evaluate (run) themselves.
//
// SyntaxTreeNode are immutable, so that a tree, once built, can be evaluated many times.
// They’re also thread-safe — the same tree could be evaluated on multiple threads at once.

protocol SyntaxTreeNode {

	var operation: SyntaxTreeOperation { get }
	var textPosition: TextPosition { get }

	func evaluate(_ stack: Stack) throws -> EvaluationResult
}
